Index: c/src/ada-tests/tmtests/tm13/tmtest.adb
===================================================================
--- c/src/ada-tests/tmtests/tm13/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm13/tmtest.adb	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,209 @@
+--
+--  TMTEST / BODY
+--
+--  DESCRIPTION:
+--
+--  This package is the implementation of Test 13 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.adb,v 1.3 1995/07/12 19:43:43 joel Exp
+--
+
+with INTERFACES; use INTERFACES;
+with RTEMS;
+with RTEMS_CALLING_OVERHEAD;
+with TEST_SUPPORT;
+with TEXT_IO;
+with TIME_TEST_SUPPORT;
+with UNSIGNED32_IO;
+
+package body TMTEST is
+
+--PAGE
+-- 
+--  INIT
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      TASK_ID : RTEMS.ID;
+      STATUS  : RTEMS.STATUS_CODES;
+   begin
+
+      TEXT_IO.NEW_LINE( 2 );
+      TEXT_IO.PUT_LINE( "*** TIME TEST 13 ***" );
+
+      RTEMS.TASK_CREATE( 
+         1,
+         251, 
+         1024, 
+         RTEMS.DEFAULT_MODES,
+         RTEMS.DEFAULT_ATTRIBUTES,
+         TASK_ID,
+         STATUS
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE" );
+
+      RTEMS.TASK_START( 
+         TASK_ID, 
+         TMTEST.TEST_INIT'ACCESS, 
+         0, 
+         STATUS 
+      );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START" );
+
+      RTEMS.TASK_DELETE( RTEMS.SELF, STATUS );
+      TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_DELETE OF SELF" );
+
+   end INIT;
+
+--PAGE
+-- 
+--  TEST_INIT
+--
+
+   procedure TEST_INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      INDEX          : RTEMS.UNSIGNED32;
+      TASK_ENTRY     : RTEMS.TASK_ENTRY_POINT;
+      PRIORITY       : RTEMS.TASK_PRIORITY;
+      TASK_ID        : RTEMS.ID;
+      BUFFER         : RTEMS.BUFFER;
+      BUFFER_POINTER : RTEMS.BUFFER_POINTER;
+      STATUS         : RTEMS.STATUS_CODES;
+   begin
+
+      BUFFER_POINTER := RTEMS.TO_BUFFER_POINTER( BUFFER'ADDRESS );
+
+-- As each task is started, it preempts this task and performs a blocking
+-- MESSAGE_QUEUE_RECEIVE.  Upon completion of this loop all created tasks
+-- are blocked.
+
+      RTEMS.MESSAGE_QUEUE_CREATE(
+         RTEMS.BUILD_NAME( 'M', 'Q', '1', ' ' ),
+         TIME_TEST_SUPPORT.OPERATION_COUNT,
+         RTEMS.DEFAULT_OPTIONS,
+         TMTEST.QUEUE_ID,
+         STATUS
+      );
+
+      PRIORITY := 250;
+
+      for INDEX in 0 .. TIME_TEST_SUPPORT.OPERATION_COUNT - 1
+      loop
+
+         RTEMS.TASK_CREATE( 
+            RTEMS.BUILD_NAME( 'T', 'I', 'M', 'E' ),
+            PRIORITY, 
+            1024, 
+            RTEMS.DEFAULT_MODES,
+            RTEMS.DEFAULT_ATTRIBUTES,
+            TASK_ID,
+            STATUS
+         );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_CREATE LOOP" );
+
+         PRIORITY := PRIORITY - 1;
+
+         if INDEX = TIME_TEST_SUPPORT.OPERATION_COUNT - 1 then
+            TASK_ENTRY := TMTEST.HIGH_TASK'ACCESS;
+         else
+            TASK_ENTRY := TMTEST.MIDDLE_TASKS'ACCESS;
+         end if;
+
+         RTEMS.TASK_START( TASK_ID, TASK_ENTRY, 0, STATUS );
+         TEST_SUPPORT.DIRECTIVE_FAILED( STATUS, "TASK_START LOOP" );
+
+      end loop;
+
+      TIMER_DRIVER.INITIALIZE;
+      RTEMS.MESSAGE_QUEUE_URGENT( 
+         TMTEST.QUEUE_ID,
+         BUFFER_POINTER,
+         STATUS
+      );
+
+   end TEST_INIT;
+
+--PAGE
+-- 
+--  HIGH_TASK
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      BUFFER         : RTEMS.BUFFER;
+      BUFFER_POINTER : RTEMS.BUFFER_POINTER;
+      STATUS         : RTEMS.STATUS_CODES;
+   begin
+
+      BUFFER_POINTER := RTEMS.TO_BUFFER_POINTER( BUFFER'ADDRESS );
+
+      RTEMS.MESSAGE_QUEUE_RECEIVE( 
+         TMTEST.QUEUE_ID,
+         BUFFER_POINTER,
+         RTEMS.DEFAULT_OPTIONS,
+         RTEMS.NO_TIMEOUT,
+         STATUS
+      );
+
+      TMTEST.END_TIME := TIMER_DRIVER.READ_TIMER;
+      TIME_TEST_SUPPORT.PUT_TIME(
+         "MESSAGE_QUEUE_URGENT (preemptive)",
+         TMTEST.END_TIME, 
+         TIME_TEST_SUPPORT.OPERATION_COUNT, 
+         0,
+         RTEMS_CALLING_OVERHEAD.MESSAGE_QUEUE_URGENT 
+      );
+
+      RTEMS.SHUTDOWN_EXECUTIVE( 0 );
+
+   end HIGH_TASK;
+
+--PAGE
+-- 
+--  MIDDLE_TASKS
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   ) is
+      BUFFER         : RTEMS.BUFFER;
+      BUFFER_POINTER : RTEMS.BUFFER_POINTER;
+      STATUS         : RTEMS.STATUS_CODES;
+   begin
+ 
+      BUFFER_POINTER := RTEMS.TO_BUFFER_POINTER( BUFFER'ADDRESS );
+
+      RTEMS.MESSAGE_QUEUE_RECEIVE( 
+         TMTEST.QUEUE_ID,
+         BUFFER_POINTER,
+         RTEMS.DEFAULT_OPTIONS,
+         RTEMS.NO_TIMEOUT,
+         STATUS
+      );
+ 
+      RTEMS.MESSAGE_QUEUE_URGENT( 
+         TMTEST.QUEUE_ID,
+         BUFFER_POINTER,
+         STATUS
+      );
+
+   end MIDDLE_TASKS;
+
+end TMTEST;
Index: c/src/ada-tests/tmtests/tm13/tmtest.ads
===================================================================
--- c/src/ada-tests/tmtests/tm13/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
+++ c/src/ada-tests/tmtests/tm13/tmtest.ads	(revision 6d4e604be8b43c0555cd1c9531fe78ae199a1189)
@@ -0,0 +1,139 @@
+--
+--  TMTEST / SPECIFICATION
+--
+--  DESCRIPTION:
+--
+--  This package is the specification for Test 13 of the RTEMS
+--  Timing Test Suite.
+--
+--  DEPENDENCIES: 
+--
+--  
+--
+--  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  On-Line Applications Research Corporation (OAR).
+--  All rights assigned to U.S. Government, 1994.
+--
+--  This material may be reproduced by or for the U.S. Government pursuant
+--  to the copyright license under the clause at DFARS 252.227-7013.  This
+--  notice must appear in all copies of this file and its derivatives.
+--
+--  tmtest.ads,v 1.3 1995/07/12 19:43:43 joel Exp
+--
+
+with TIMER_DRIVER;
+with RTEMS;
+
+package TMTEST is
+
+--
+--  The following is the ID of the message queue used for timing operations.
+--
+
+   QUEUE_ID : RTEMS.ID;
+
+--
+--  The following variable is set to the execution time returned
+--  by the timer.
+--
+
+   END_TIME  : RTEMS.UNSIGNED32;
+
+--
+--  INIT
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task initializes the application.
+--
+
+   procedure INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  TEST_INIT
+--
+--  DESCRIPTION:
+--
+--  This subprogram performs test initialization.  As each application
+--  task is created and started, it will preempt this task and
+--  perform a blocking MESSAGE_QUEUE_RECEIVE.  Once all of the 
+--  initialization is completed, the timer is started and the first 
+--  preemptive MESSAGE_QUEUE_URGENT is executed.
+--
+
+   procedure TEST_INIT (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  HIGH_TASK
+--
+--  DESCRIPTION:
+--
+--  This RTEMS task is the highest priority task in the system.  
+--  It performs a blocking blocking MESSAGE_QUEUE_RECEIVE.  It is
+--  the last test task created and started.  Thus it is the last 
+--  task to be enqueued waiting for a message and the last task
+--  to receive the message.  Once it receives the message, it
+--  stops the timer and reports the execution time for a
+--  preemptive MESSAGE_QUEUE_URGENT.
+--
+
+   procedure HIGH_TASK (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  MIDDLE_TASKS
+--
+--  DESCRIPTION:
+--
+--  As each of these RTEMS tasks is created and started, it preempts
+--  the initialization task and perform a blocking MESSAGE_QUEUE_RECEIVE.
+--
+
+   procedure MIDDLE_TASKS (
+      ARGUMENT : in     RTEMS.TASK_ARGUMENT
+   );
+
+--
+--  This is the Initialization Tasks Table for this test.
+--
+
+   INITIALIZATION_TASKS : aliased RTEMS.INITIALIZATION_TASKS_TABLE( 1 .. 1 ) := 
+   (1=>
+     (
+       RTEMS.BUILD_NAME( 'U', 'I', '1', ' ' ),        -- task name
+       2048,                                          -- stack size
+       1,                                             -- priority
+       RTEMS.DEFAULT_ATTRIBUTES,                      -- attributes
+       TMTEST.INIT'ACCESS,                            -- entry point
+       RTEMS.NO_PREEMPT,                              -- initial mode
+       0                                              -- argument list
+     )
+   );
+
+--
+--  This is the Configuration Table for this test.
+--
+
+   CONFIGURATION : aliased RTEMS.CONFIGURATION_TABLE := (
+      RTEMS.NULL_ADDRESS,        -- will be replaced by BSP
+      256 * 1024,                -- executive RAM size
+      111,                       -- maximum # tasks
+      0,                         -- maximum # timers
+      0,                         -- maximum # semaphores
+      1,                         -- maximum # message queues
+      100,                       -- maximum # messages
+      0,                         -- maximum # partitions
+      0,                         -- maximum # regions
+      0,                         -- maximum # dp memory areas
+      0,                         -- maximum # periods
+      0,                         -- maximum # user extensions
+      RTEMS.MILLISECONDS_TO_MICROSECONDS(10), -- # us in a tick
+      0                          -- # ticks in a timeslice
+  );
+
+end TMTEST;
